var FormsParser = 
{
    xmlToJson: function(xml, global_obj, flag)
    {
        var obj = {};
        var isChildless = false;
        
        if (xml.nodeType == 1)
        {
            if (xml.attributes.length > 0)
            {
                obj['@attributes'] = {};
                for (var j = 0; j < xml.attributes.length; j++)
                {
                    var attribute = xml.attributes.item(j);                
                    if(flag)
                        obj['@attributes'][attribute.nodeName] = attribute.nodeValue;
                    else
                        global_obj['@attributes'][attribute.nodeName] = attribute.nodeValue;
                }
            }
        }

        if (xml.hasChildNodes())
        {
            for (var i = 0; i < xml.childNodes.length; i++)
            {
                var item = xml.childNodes.item(i);
                var nodeName = item.nodeName;

                if (typeof (obj[nodeName]) == 'undefined')
                {
                    obj[nodeName] = FormsParser.xmlToJson(item, global_obj, true);
                }
                else
                {                
                    if (typeof (obj[nodeName].length) == 'undefined')
                    {
                        var old = obj[nodeName];
                        obj[nodeName] = [];
                        obj[nodeName].push(old);
                    }
                    if(nodeName.toUpperCase() == 'INPUT')
                        obj[nodeName].push(FormsParser.xmlToJson(item, global_obj, true));
                    else if(nodeName.toUpperCase() == 'SELECT' || nodeName.toUpperCase() == 'OPTION')
                    {
                        if(typeof(obj['@attributes']) == 'undefined')
                            obj['@attributes'] = {};
                        obj['@attributes']['type'] = nodeName.toLowerCase();
                        obj[nodeName].push(FormsParser.xmlToJson(item, global_obj, true));
                    }
                    else
                        FormsParser.xmlToJson(item, global_obj, true);
                }
            }
        }
        else
        {
            // childless node
            isChildless = true;
        }
        
        obj.nodeName = xml.nodeName;        
        if($(xml).is(':hidden') && ((typeof(obj['@attributes']) == 'undefined') || (obj['@attributes']['type'] != 'hidden'))) flag = false;
        
        // We take all inputs and select with name or id attribute (cause we identify inputs by them)
        // and if they have type attribute, it shouldn\'t be hidden or submit (if it doesn\'t have type attribute, it is can be plain text used for login/username)
        // (typeof(obj['@attributes']['name']) != 'undefined') &&
        // if(flag && (typeof(obj['@attributes'])         != 'undefined') &&    
        //            (typeof(obj['@attributes']['name']) != 'undefined') &&
        //            (((typeof(obj['@attributes']['type']) != 'undefined') && (obj['@attributes']['type'] != 'hidden') && (obj['@attributes']['type'] != 'submit')) || (typeof(obj['@attributes']['type']) == 'undefined')))                                                                                                              
        if(flag &&
           (typeof(obj['@attributes']) != 'undefined') &&
           ((typeof(obj['@attributes']['name']) != 'undefined' && obj['@attributes']['name'].indexOf('invisible') == -1) ||
            (typeof(obj['@attributes']['id']) != 'undefined' && obj['@attributes']['id'].indexOf('invisible') == -1)) &&
           (typeof(obj['@attributes']['type']) != 'undefined' || typeof(obj['@attributes']['maxlength']) != 'undefined') &&
           (typeof(obj['@attributes']['type']) != 'undefined' && obj['@attributes']['type'].toLowerCase() != 'submit') &&
           (typeof(obj['@attributes']['type']) != 'undefined' && obj['@attributes']['type'].toLowerCase() != 'button') &&           
           (typeof(obj['@attributes']['type']) != 'undefined' && obj['@attributes']['type'].toLowerCase() != 'image')  &&
           (typeof(obj['@attributes']['type']) == 'undefined' || obj['@attributes']['type'].indexOf('application') == -1))
               {
                   global_obj['input_elements'].push(obj);
               }
        else 
        {            
            if(flag &&
                    (typeof(obj['@attributes']) != 'undefined') &&
                    (typeof(obj['@attributes']['type']) == 'undefined') &&
                    ((typeof(obj['@attributes']['name']) != 'undefined' && (obj['@attributes']['name'].indexOf('login') != -1 || obj['@attributes']['name'].indexOf('user') != -1)) ||
                     (typeof(obj['@attributes']['id']) != 'undefined' && (obj['@attributes']['id'].indexOf('login') != -1 || obj['@attributes']['id'].indexOf('user') != -1))))
            {
                // [HACK] there is a hack for inputs with no type, assumed type is text       
                // $(xml)[0].nodeName == 'LABEL'
                // $(xml)[0].nodeName == 'SPAN'
                
                if(isChildless &&
                   (typeof $(xml)[0].nodeName != 'undefined' && ($(xml)[0].nodeName == 'INPUT' || $(xml)[0].nodeName == 'DIV')))            
                {
                    global_obj['input_elements'].push(obj);            
                }
            }
        }
        return obj;
    },    
	findFormsInDOM: function()
	{
        var pageFormObjects = [];
        for(var i = 0; i < BrowserSpecific.GetDocument().forms.length; i++)
        {
            var anotherForm = BrowserSpecific.GetDocument().forms[i];
            
            //  BrowserSpecific.GetDocument().forms.length
            // [TODO] check forms visibility
            if($(anotherForm).attr('kpm_formParsed') === 'true')
                continue;
            
            // if($(anotherForm).attr('kpm_formParsed') === 'true' && $(anotherForm).attr('kpm_formWasVisibleOnParsing') === $(anotherForm).is(':visible'))
            //     continue;
                
            if($(anotherForm).is(':hidden'))
                continue;
                
            $(anotherForm).attr('kpm_formParsed', 'true');
            
            // $(anotherForm).attr('kpm_formWasVisibleOnParsing', $(anotherForm).is(':visible'));
            
            var formHasSubmitObject = ($(anotherForm).find('input[type=\'submit\']').length > 0);
            if(!formHasSubmitObject)            
                formHasSubmitObject = ($(anotherForm).find('button').length > 0)
            if(!formHasSubmitObject)
                $(anotherForm).find('a,div,input').each(function(){
                    if(!formHasSubmitObject &&
                        ((typeof $(this).attr('name') != 'undefined' && $(this).attr('name').toLowerCase().indexOf('submit')  != -1) ||
                         (typeof $(this).attr('name') != 'undefined' && $(this).attr('name').toLowerCase().indexOf('log')     != -1) ||
                         (typeof $(this).attr('id')   != 'undefined' && $(this).attr('id').toLowerCase().indexOf('submit')    != -1) ||
                         (typeof $(this).attr('id')   != 'undefined' && $(this).attr('id').toLowerCase().indexOf('log')       != -1) ||
                         (typeof $(this).attr('class')!= 'undefined' && $(this).attr('class').toLowerCase().indexOf('submit') != -1) ||
                         (typeof $(this).attr('class')!= 'undefined' && $(this).attr('class').toLowerCase().indexOf('log')    != -1) ||
                         (typeof $(this).attr('type') != 'undefined' && $(this).attr('type').toLowerCase() == 'submit')))
                    {
                        formHasSubmitObject = true;
                        return;
                    }                    
                });
            
            var obj = {'input_elements' : [],
                       '@attributes'    : {},
                       'URL'            : BrowserSpecific.GetDocument().location,
                       'has_submit'     : formHasSubmitObject };
            FormsParser.xmlToJson(anotherForm, obj, false);
            pageFormObjects.push(obj);
        }        
        return pageFormObjects;
	},
    // findSeparateInputsInDOM: function()
    // {
    //     var inputs = $('input');
    //     var ret = [];
    //         for(var inpt in inputs)
    //             if($(inputs[inpt]).parents('form').length == 0)
    //                 ret.append($(inputs[inpt]);
    //         return ret;
    // },
	
	placeholderRemovalFromObject: function(obj, select)
	{
	    var plchldr = $(obj).parents('form').find(select);
	    $(plchldr).each(function(){
	        if($(this).children().length <= 0 && $(this)[0].nodeName.toLowerCase() != 'input')
	            $(this).remove()
        });
	},
	
	fillFormInDOM: function(data)
	{
	    for(var i = 0; i < data['form_fields'].length; i++)
	    {
	        if(typeof(data['form_fields'][i]['transform']) != 'undefined')
    	        var dataToFill = eval('(\'' + data['form_fields'][i]['kpm_value'] + '\')' + data['form_fields'][i]['transform']);
    	    else
    	        var dataToFill = data['form_fields'][i]['kpm_value'];
    	    
    	    if(typeof(dataToFill) == 'undefined' || dataToFill.length === 0)
    	        continue;
    	        
            if(typeof data['action'] != 'undefined' && data['action'].length > 0)
                var formSearchQuery = 'form[action*=\'' + data['action'] + '\']';
            else
    	        var formSearchQuery = 'form';

    	    //
            // fill radio buttons
            // [TODO]
    	    
    	    //
	        // fill combobox
	        // now check, if text inside option tag 'heuristically match' kpm_value
	        if(typeof data['form_fields'][i]['input_id'] != 'undefined')
    	        var allOptions = $(formSearchQuery).find('select[id=\'' + data['form_fields'][i]['input_id'] + '\']').find('option');
    	    else
        	    var allOptions = $(formSearchQuery).find('select[name=\'' + data['form_fields'][i]['input_name'] + '\']').find('option');
        	var wasFilled = false;
	        for(var j = 0; j < allOptions.length; j++)
	        {
	            var localizableString = allOptions[j].text.toLowerCase();
                $(allOptions[j]).removeAttr('selected');
                
                // [TODO] translate label to english
                
                if(localizableString == dataToFill || $(allOptions[j]).filter('option[value*=\'' + dataToFill + '\']').length > 0)
                {
    	            $(allOptions[j]).parents('select').each(function(){ 
    	                wasFilled = true;
	                    $(this)[0].options[j].selected = true; 
    	            });
    	            break;
                }
            }	        
            if(!wasFilled)
                $(allOptions[parseInt(dataToFill)]).parents('select').each(function(){ 
                    wasFilled = true;                    
                    $(this)[0].options[parseInt(dataToFill)].selected = true; 
	            });
            if(!wasFilled)
                $(allOptions[0]).parents('select').each(function(){ 
                    wasFilled = true;                    
                    $(this)[0].options[0].selected = true; 
	            });
	        
	        //
            // fill input
            if(typeof data['form_fields'][i]['input_name'] != 'undefined')
                var inputToFill = $(formSearchQuery).find('input[name=\'' + data['form_fields'][i]['input_name'] + '\']');
            else if(typeof data['form_fields'][i]['input_id'] != 'undefined')
                var inputToFill = $(formSearchQuery).find('input[id=\'' + data['form_fields'][i]['input_id'] + '\']');                            
            // else [TODO] well, this is impossible
            
            if(typeof inputToFill != 'undefined')
            {
                // removing placeholders
                $(inputToFill).each(function(){
                    FormsParser.placeholderRemovalFromObject(this, '*[id*=\'place\']');
                    FormsParser.placeholderRemovalFromObject(this, '*[name*=\'place\']');    
                    FormsParser.placeholderRemovalFromObject(this, '*[class*=\'place\']');                    
                    FormsParser.placeholderRemovalFromObject(this, '*[id*=\'hint\']');                    
                    FormsParser.placeholderRemovalFromObject(this, '*[name*=\'hint\']');                    
                    FormsParser.placeholderRemovalFromObject(this, '*[class*=\'hint\']');    
                });
                
                // set input value
                $(inputToFill).each(function(){
                    if(typeof $(this).attr('type') !== 'undefined' && $(this).attr('type').toLowerCase() == 'radio')
                    {
                        if((typeof $(this).attr('name') != 'undefined'  && $(this).attr('name').indexOf('fem') != -1)  ||
                           (typeof $(this).attr('id') != 'undefined'    && $(this).attr('id').indexOf('fem') != -1)    ||
                           (typeof $(this).attr('class') != 'undefined' && $(this).attr('class').indexOf('fem') != -1) ||
                           $(this).attr('value') !== '1')
                            $(this)[0].checked = (dataToFill === '2');
                        else
                            $(this)[0].checked = (dataToFill !== '2');
                    }
                    else
                        $(this).val(dataToFill);
                });
            }
        }
        
        // find 
        var showFunction = function(event){    
            $('.kpm_unknownIdentityField').remove();
            var variantSelectFunction = function(){
                UI.shouldRemoveList = 2;
                
                $(event.target).val($(this).attr('value'));
                FormsParser.placeholderRemovalFromObject(event.target, '*[id*=\'place\']');
                FormsParser.placeholderRemovalFromObject(event.target, '*[name*=\'place\']');    
                FormsParser.placeholderRemovalFromObject(event.target, '*[class*=\'place\']');                    
                FormsParser.placeholderRemovalFromObject(event.target, '*[id*=\'hint\']');                    
                FormsParser.placeholderRemovalFromObject(event.target, '*[name*=\'hint\']');                    
                FormsParser.placeholderRemovalFromObject(event.target, '*[class*=\'hint\']');    
                                
                $('.kpm_unknownIdentityField').remove();                                             
            };

            var variants = [];
            for(var j = 0; j < data['all_fields'].length; j++)
                if(typeof data['all_fields'][j] !== 'undefined' && data['all_fields'][j].length > 0 && data['all_fields'][j] !== '')
                    variants.push({value   : data['all_fields'][j],
                                   html    : data['all_fields'][j]});
            if(variants.length <= 0)
                return;
            var variantsList = UI.CreateKPMVariantsList(variants, variantSelectFunction);
            $(variantSelectFunction).attr('form_index', 0);
            var dialog = UI.CreateKPMDialog(UI.Localization.getString('extensionAuthor'), variantsList, event.target);

            // make dialog invisible
            dialog.css({'display' : 'none'});
            // inject to the page
            $(dialog).addClass('kpm_unknownIdentityField');
            $(BrowserSpecific.GetDocument().body).append(dialog);        
            // adjust positioning
            UI.StickDialogPositionToElement(dialog, event.target);
            // make dialog visible
            dialog.css({'display' : 'block'});            
        };
        
        var hideFunction = function(event){
            UI.shouldRemoveList = 1;
            $(document).mouseup(function(){
                setTimeout(function(){
                    if(UI.shouldRemoveList == 1)
                        $('.kpm_unknownIdentityField').remove();                    
                }, 100);
            });
        };
        
        var formInputs = $('input[name=\'' + data['form_fields'][0]['input_name'] + '\']').parents('form').find('input');
        for(var i = 0; i < formInputs.length; i++)
        {
            if($(formInputs[i]).attr('type') != 'hidden' &&
               $(formInputs[i]).attr('type') != 'submit')
            {
                // 
                //if(data.kpm_templateId == 'signupTemplate')
                if(data.kpm_templateId != 'simpleLoginPasswordCheckboxForm' && data.kpm_templateId != 'empty_form')
                {                
                    $(formInputs[i]).on('focus', function(event){
                        if($(event.target).val().length == 0)
                            showFunction(event);
                    });
                    $(formInputs[i]).on('blur', function(event){
                        hideFunction(event);
                    });                
                }
            }
        }
	},
	
	parseFormObject: function(formObject)
	{
	    // [TODO] Use somehow updatable scripts
	    return HeuristicParser.parseUnknownForm(formObject);
	}
    // tryFindSmthUseful: function(input)
    // {
    //     return HeuristicParser.parseUnknownInput(input);
    // }
};