/*
    HeuristicParser returns form template:
    
    {
        'kpm_templateId': <kpm_templateId>,
        'form_fields':  [
                            { 'kpm_type' : <kpm_type>,
                              'input_name' : <str> },
                        ]
    }
    
    This template should be passed to db controller
*/

var heuristicFormTemplates = [
{
    id     : 'creditCardTemplate',    
    max_fields_in_form: 42,
    min_fields_in_form: 3,
    unknown_fields_allowed: true,   
    can_have_hidden_fields: true,    
    fields : [            
        // {
        //     kpm_type: 'CardHolderName',
        //     required: false,
        //     inputIndexes: [],
        //     maxInputs: 1,
        //     predicates: [{type   : 'text',
        //                   checks : []}]
        // },                
        {
            // [FIXME] can be messed with phone number
            kpm_type: 'Identity_CreditCard_CardNumber',
            required: true,
            inputIndexes: [],
            maxInputs: 1,
            exactNumber: false,
            predicates: [{type   : 'text',
                         checks : [{attrName : 'name',  attrValue : 'number'}, // could be 4 fields?
                                   {attrName : 'id',    attrValue : 'number'},
                                   {attrName : 'class', attrValue : 'number'},
                                   {attrName : 'name',  attrValue : 'pan'},
                                   {attrName : 'id',    attrValue : 'pan'},
                                   {attrName : 'class', attrValue : 'pan'}]}]
        },        
        {
            kpm_type: 'Identity_CreditCard_ValidationCode',
            required: true,
            inputIndexes: [],
            maxInputs: 1,
            exactNumber: false,            
            predicates: [{type   : 'text',
                          checks : []}]

        },
        {
            kpm_type: 'Identity_CreditCard_ExpDate',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            exactNumber: false,            
            predicates: [{type   : 'text',
                          checks : [{attrName : 'name', attrValue : 'date'},
                                    {attrName : 'id',   attrValue : 'date'},
                                    {attrName : 'name', attrValue : 'exp'},
                                    {attrName : 'id',   attrValue : 'exp' }]}                         
                        ]

        },
        {
            kpm_type: 'Identity_CreditCard_CardType',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            exactNumber: false,            
            predicates: [{type   : 'option',
                          checks : [{attrName : 'name', attrValue : 'type'},
                                    {attrName : 'id',   attrValue : 'type'}]}
                        ]

        },        
        {
            kpm_type: 'Identity_CreditCard_ExpDate',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            transform: '.split(\'/\')[0]',            
            exactNumber: false,            
            predicates: [{type   : 'text',
                          checks : [{attrName : 'name', attrValue : 'month'},
                                    {attrName : 'id',   attrValue : 'month'}]},
                         {type   : 'option',
                          checks : [{attrName : 'name', attrValue : 'month'},
                                    {attrName : 'id',   attrValue : 'month'}]}
                        ]

        },
        {
            kpm_type: 'Identity_CreditCard_ExpDate',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            transform: '.split(\'/\')[1]',            
            exactNumber: false,            
            predicates: [{type   : 'text',
                          checks : [{attrName : 'name', attrValue : 'year'},
                                    {attrName : 'id',   attrValue : 'year'}]},
                         {type   : 'option',
                          checks : [{attrName : 'name', attrValue : 'year'},
                                    {attrName : 'id',   attrValue : 'year'}]}
                        ]

        }
        
    ]
},
{
    id     : 'simpleLoginPasswordCheckboxForm',
    unknown_fields_allowed: false,
    max_fields_in_form: 5,
    min_fields_in_form: 2,
    fields : [
        {
            kpm_type: 'login_aux',
            required: false,
            inputIndexes: [],
            maxInputs: 2,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'name', attrValue : 'login' },
                                    {attrName : 'name', attrValue : 'user'  },
                                    {attrName : 'name', attrValue : 'sign'  },
                                    {attrName : 'name', attrValue : 'domain'},
                                    {attrName : 'name', attrValue : 'targ'  },
                                    {attrName : 'name', attrValue : 'alias' },                                    
                                    {attrName : 'id',   attrValue : 'login' },
                                    {attrName : 'id',   attrValue : 'user'  },
                                    {attrName : 'id',   attrValue : 'sign'  },
                                    {attrName : 'id',   attrValue : 'domain'},
                                    {attrName : 'id',   attrValue : 'targ'  },
                                    {attrName : 'id',   attrValue : 'alias' },
                                    {attrName : 'class', attrValue : 'login' },
                                    {attrName : 'class', attrValue : 'user'  },
                                    {attrName : 'class', attrValue : 'sign'  },
                                    {attrName : 'class', attrValue : 'domain'},
                                    {attrName : 'class', attrValue : 'targ'  },
                                    {attrName : 'class', attrValue : 'alias' }]},
                         {type   : 'radio',
                          checks : [{attrName : 'name', attrValue : 'login'},
                                    {attrName : 'name', attrValue : 'user' },
                                    {attrName : 'name', attrValue : 'sign' },
                                    {attrName : 'name', attrValue : 'targ' },
                                    {attrName : 'name', attrValue : 'alias'},
                                    {attrName : 'id',   attrValue : 'login'},
                                    {attrName : 'id',   attrValue : 'user' },
                                    {attrName : 'id',   attrValue : 'sign' },
                                    {attrName : 'id',   attrValue : 'targ' },
                                    {attrName : 'id',   attrValue : 'alias'},
                                    {attrName : 'class', attrValue : 'login'},
                                    {attrName : 'class', attrValue : 'user' },
                                    {attrName : 'class', attrValue : 'sign' },
                                    {attrName : 'class', attrValue : 'targ' },
                                    {attrName : 'class', attrValue : 'alias'}]},
                         {type   : '*',
                          checks : [{attrName : 'name', attrValue : 'check'  },
                                    {attrName : 'name', attrValue : 'code'   },                                    
                                    {attrName : 'name', attrValue : 'answer' },                                    
                                    {attrName : 'name', attrValue : 'captcha'},
                                    {attrName : 'name', attrValue : 'guess'  },                                    
                                    {attrName : 'name', attrValue : 'place'  },
                                    {attrName : 'name', attrValue : 'alias'  },
                                    {attrName : 'id',   attrValue : 'check'  },
                                    {attrName : 'id',   attrValue : 'code'   },
                                    {attrName : 'id',   attrValue : 'answer' },
                                    {attrName : 'id',   attrValue : 'captcha'},
                                    {attrName : 'id',   attrValue : 'guess'  },
                                    {attrName : 'id',   attrValue : 'place'  },
                                    {attrName : 'id',   attrValue : 'alias'  },
                                    {attrName : 'class', attrValue : 'check'  },
                                    {attrName : 'class', attrValue : 'code'   },                                    
                                    {attrName : 'class', attrValue : 'answer' },                                    
                                    {attrName : 'class', attrValue : 'captcha'},
                                    {attrName : 'class', attrValue : 'guess'  },                                    
                                    {attrName : 'class', attrValue : 'place'  },
                                    {attrName : 'class', attrValue : 'alias'  }]}]
        
        },    
        {
            kpm_type: 'login',
            required: true,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : '*',
                          checks : [{attrName : 'name', attrValue : 'login'},
                                    {attrName : 'name', attrValue : 'user' },                                    
                                    {attrName : 'id',   attrValue : 'login'},
                                    {attrName : 'id',   attrValue : 'user' }]},
                         {type   : 'email',
                          checks : []},
                         {type   : 'text',
                          checks : []}]
            
        },  
        {
            kpm_type: 'login_aux',
            required: false,
            inputIndexes: [],
            maxInputs: 2,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'name', attrValue : 'login' },
                                    {attrName : 'name', attrValue : 'user'  },
                                    {attrName : 'name', attrValue : 'sign'  },
                                    {attrName : 'name', attrValue : 'domain'},
                                    {attrName : 'name', attrValue : 'targ'  },
                                    {attrName : 'name', attrValue : 'alias' },                                    
                                    {attrName : 'id',   attrValue : 'login' },
                                    {attrName : 'id',   attrValue : 'user'  },
                                    {attrName : 'id',   attrValue : 'sign'  },
                                    {attrName : 'id',   attrValue : 'domain'},
                                    {attrName : 'id',   attrValue : 'targ'  },
                                    {attrName : 'id',   attrValue : 'alias' },
                                    {attrName : 'class', attrValue : 'login' },
                                    {attrName : 'class', attrValue : 'user'  },
                                    {attrName : 'class', attrValue : 'sign'  },
                                    {attrName : 'class', attrValue : 'domain'},
                                    {attrName : 'class', attrValue : 'targ'  },
                                    {attrName : 'class', attrValue : 'alias' }]},
                         {type   : 'radio',
                          checks : [{attrName : 'name', attrValue : 'login'},
                                    {attrName : 'name', attrValue : 'user' },
                                    {attrName : 'name', attrValue : 'sign' },
                                    {attrName : 'name', attrValue : 'targ' },
                                    {attrName : 'name', attrValue : 'alias'},
                                    {attrName : 'id',   attrValue : 'login'},
                                    {attrName : 'id',   attrValue : 'user' },
                                    {attrName : 'id',   attrValue : 'sign' },
                                    {attrName : 'id',   attrValue : 'targ' },
                                    {attrName : 'id',   attrValue : 'alias'},
                                    {attrName : 'class', attrValue : 'login'},
                                    {attrName : 'class', attrValue : 'user' },
                                    {attrName : 'class', attrValue : 'sign' },
                                    {attrName : 'class', attrValue : 'targ' },
                                    {attrName : 'class', attrValue : 'alias'}]},
                         {type   : '*',
                          checks : [{attrName : 'name', attrValue : 'check'  },
                                    {attrName : 'name', attrValue : 'code'   },                                    
                                    {attrName : 'name', attrValue : 'answer' },                                    
                                    {attrName : 'name', attrValue : 'captcha'},
                                    {attrName : 'name', attrValue : 'guess'  },                                    
                                    {attrName : 'name', attrValue : 'place'  },
                                    {attrName : 'name', attrValue : 'alias'  },
                                    {attrName : 'id',   attrValue : 'check'  },
                                    {attrName : 'id',   attrValue : 'code'   },
                                    {attrName : 'id',   attrValue : 'answer' },
                                    {attrName : 'id',   attrValue : 'captcha'},
                                    {attrName : 'id',   attrValue : 'guess'  },
                                    {attrName : 'id',   attrValue : 'place'  },
                                    {attrName : 'id',   attrValue : 'alias'  },
                                    {attrName : 'class', attrValue : 'check'  },
                                    {attrName : 'class', attrValue : 'code'   },                                    
                                    {attrName : 'class', attrValue : 'answer' },                                    
                                    {attrName : 'class', attrValue : 'captcha'},
                                    {attrName : 'class', attrValue : 'guess'  },                                    
                                    {attrName : 'class', attrValue : 'place'  },
                                    {attrName : 'class', attrValue : 'alias'  }]}]
        
        },        
        {
            kpm_type: 'password',
            required: true,
            exactNumber: true, // number of inputs shouldn't be more than maxInputs
            inputIndexes: [],            
            maxInputs: 1,            
            predicates: [{type   : 'password',
                          checks : []}]
        },
        {
            kpm_type: 'captcha',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : '*',
                          checks : [{attrName : 'name', attrValue : 'code' },
                                    {attrName : 'name', attrValue : 'code' },                                    
                                    {attrName : 'id',   attrValue : 'check'},
                                    {attrName : 'id',   attrValue : 'check'}]}]
        
        },
        {
            kpm_type: 'login_aux',
            required: false,
            inputIndexes: [],
            maxInputs: 2,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'name', attrValue : 'login' },
                                    {attrName : 'name', attrValue : 'user'  },
                                    {attrName : 'name', attrValue : 'sign'  },                                    
                                    {attrName : 'name', attrValue : 'domain'},
                                    {attrName : 'name', attrValue : 'targ'  },
                                    {attrName : 'id',   attrValue : 'login' },
                                    {attrName : 'id',   attrValue : 'user'  },
                                    {attrName : 'id',   attrValue : 'sign'  },
                                    {attrName : 'id',   attrValue : 'domain'},
                                    {attrName : 'id',   attrValue : 'targ'  },
                                    {attrName : 'class',   attrValue : 'login' },
                                    {attrName : 'class',   attrValue : 'user'  },
                                    {attrName : 'class',   attrValue : 'sign'  },
                                    {attrName : 'class',   attrValue : 'domain'},
                                    {attrName : 'class',   attrValue : 'targ'  }]},
                         {type   : 'radio',
                          checks : [{attrName : 'name', attrValue : 'login'},
                                    {attrName : 'name', attrValue : 'user' },
                                    {attrName : 'name', attrValue : 'sign' },
                                    {attrName : 'name', attrValue : 'targ' },
                                    {attrName : 'id',   attrValue : 'login'},
                                    {attrName : 'id',   attrValue : 'user' },
                                    {attrName : 'id',   attrValue : 'sign' },
                                    {attrName : 'id',   attrValue : 'targ' },
                                    {attrName : 'class', attrValue : 'login'},
                                    {attrName : 'class', attrValue : 'user' },
                                    {attrName : 'class', attrValue : 'sign' },
                                    {attrName : 'class', attrValue : 'targ' }]},
                         {type   : '*',
                          checks : [{attrName : 'name', attrValue : 'check' },
                                    {attrName : 'name', attrValue : 'code'  },                                    
                                    {attrName : 'name', attrValue : 'answer'},                                    
                                    {attrName : 'id',   attrValue : 'check' },
                                    {attrName : 'id',   attrValue : 'code'  },
                                    {attrName : 'id',   attrValue : 'answer'},
                                    {attrName : 'class', attrValue : 'check' },
                                    {attrName : 'class', attrValue : 'code'  },                                    
                                    {attrName : 'class', attrValue : 'answer'}]}]
        
        },                    
        {
            kpm_type: 'rememberCheckbox',
            required: false,
            inputIndexes: [],            
            maxInputs: 1,            
            predicates: [{type   : 'checkbox',
                          checks : []}]
        },
        {
            kpm_type: 'captcha',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : '*',
                          checks : [{attrName : 'name', attrValue : 'code' },
                                    {attrName : 'name', attrValue : 'code' },                                    
                                    {attrName : 'id',   attrValue : 'check'},
                                    {attrName : 'id',   attrValue : 'check'}]}]
        
        }        
    ]
},
{
    id     : 'signupTemplate',  
    unknown_fields_allowed: true,   
    can_have_hidden_fields: true,
    max_fields_in_form: 42, // [HACK] cuttin off very big search forms
                            // -1 means do not check
    min_fields_in_form: 3, // counts only non-hidden, non-submit inputs
    
    must_not_contain: [{type        : ['text', 'password'],
                        min_amount  : 2},    
                       {type        : 'file',
                        max_amount  : 0},
                       {nodeName    : 'select',
                        max_amount  : 8},
                       {nodeName    : 'checkbox',
                        max_amount  : 6},
                       {nodeName    : 'textarea',
                        max_amount  : 0}], // signup forms should not contain these elements (!)
    
    fields : [            
        {
            kpm_type: 'Identity_Person_FirstName',
            required: false, // [WARNING] this may lead to massive form parsing trash
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'text',
                          checks : []}]

        },         
        {
            kpm_type: 'Identity_Contact_EMail',
            required: false,
            inputIndexes: [],            
            maxInputs: 2,            
            predicates: [{type   : 'email',
                          checks : []},
                         {type   : '*',
                          checks : [{attrName : 'title', attrValue : 'mail'},
                                    {attrName : 'name', attrValue : 'mail'},
                                    {attrName : 'id',   attrValue : 'mail'}]}]
        }, 
        {
            kpm_type: 'Identity_Person_LastName',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'text',
                          checks : []}]

        },          
        {
            kpm_type: 'Identity_Person_MartialStatus',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'mart'},
                                    {attrName : 'name', attrValue : 'mart'},
                                    {attrName : 'id',   attrValue : 'mart'},
                                    {attrName : 'title', attrValue : 'status'},
                                    {attrName : 'name', attrValue : 'status'},
                                    {attrName : 'id',   attrValue : 'status'}]}]
        },                   
        {
            kpm_type: 'Identity_Person_Gender',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'gender'},
                                    {attrName : 'name', attrValue : 'gender'},
                                    {attrName : 'id',   attrValue : 'gender'},
                                    {attrName : 'title', attrValue : 'sex'},
                                    {attrName : 'name', attrValue : 'sex'},
                                    {attrName : 'id',   attrValue : 'sex'},
                                    {attrName : 'title', attrValue : 'man'},
                                    {attrName : 'name', attrValue : 'man'},
                                    {attrName : 'id',   attrValue : 'man'}]},
                        {type   : 'radio',
                         checks : [{attrName : 'title', attrValue : 'gender'},
                                   {attrName : 'name', attrValue : 'gender'},
                                   {attrName : 'id',   attrValue : 'gender'},
                                   {attrName : 'title', attrValue : 'sex'},
                                   {attrName : 'name', attrValue : 'sex'},
                                   {attrName : 'id',   attrValue : 'sex'},
                                   {attrName : 'title', attrValue : 'man'},
                                   {attrName : 'name', attrValue : 'man'},
                                   {attrName : 'id',   attrValue : 'man'}]},                                    
                         {type   : 'hidden',
                          checks : [{attrName : 'title', attrValue : 'gender'},
                                    {attrName : 'name', attrValue : 'gender'},
                                    {attrName : 'id',   attrValue : 'gender'},
                                    {attrName : 'title', attrValue : 'sex'},
                                    {attrName : 'name', attrValue : 'sex'},
                                    {attrName : 'id',   attrValue : 'sex'},
                                    {attrName : 'title', attrValue : 'man'},
                                    {attrName : 'name', attrValue : 'man'},
                                    {attrName : 'id',   attrValue : 'man'}]}]
        },                
        {
            kpm_type: 'Identity_Person_BirthDate',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            transform: '.split(\'/\')[0]', // [TOTHINK] it's impossible to stringify function object, but from plugin to code objects are being passed as strings
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'month'},
                                    {attrName : 'class', attrValue : 'month'},                          
                                    {attrName : 'name', attrValue : 'month'},
                                    {attrName : 'id',   attrValue : 'month'}]},
                         {type   : 'hidden', // [HACK] Google-specific hack
                          checks : [{attrName : 'title', attrValue : 'month'},
                                    {attrName : 'class', attrValue : 'month'},                          
                                    {attrName : 'name', attrValue : 'month'},
                                    {attrName : 'id',   attrValue : 'month'}]},
                         {type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'month'},
                                    {attrName : 'class', attrValue : 'month'},                          
                                    {attrName : 'name', attrValue : 'month'},
                                    {attrName : 'id',   attrValue : 'month'}]}]

        },                
        {
            kpm_type: 'Identity_Person_BirthDate',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            transform: '.split(\'/\')[1]',
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'day'},
                                    {attrName : 'class', attrValue : 'day'},                          
                                    {attrName : 'name', attrValue : 'day'},
                                    {attrName : 'id',   attrValue : 'day'}]},
                         {type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'day'},
                                    {attrName : 'class', attrValue : 'day'},                          
                                    {attrName : 'name', attrValue : 'day'},
                                    {attrName : 'id',   attrValue : 'day'}]}]

        },
        {
            kpm_type: 'Identity_Person_BirthDate',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            transform: '.split(\'/\')[2]',
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'year'},
                                    {attrName : 'class', attrValue : 'year'},                          
                                    {attrName : 'name', attrValue : 'year'},
                                    {attrName : 'id',   attrValue : 'year'}]},
                         {type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'year'},
                                    {attrName : 'class', attrValue : 'year'},                          
                                    {attrName : 'name', attrValue : 'year'},
                                    {attrName : 'id',   attrValue : 'year'}]}]

        },
        {
            kpm_type: 'Identity_Person_Gender',
            required: false,
            inputIndexes: [],            
            maxInputs: 2,            
            predicates: [{type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'gender'},
                                    {attrName : 'name', attrValue : 'gender'},
                                    {attrName : 'id',   attrValue : 'gender'},
                                    {attrName : 'title', attrValue : 'sex'},
                                    {attrName : 'name', attrValue : 'sex'},
                                    {attrName : 'id',   attrValue : 'sex'},
                                    {attrName : 'title', attrValue : 'man'},
                                    {attrName : 'name', attrValue : 'man'},
                                    {attrName : 'id',   attrValue : 'man'}]},
                         {type   : 'radio',
                          checks : [{attrName : 'title', attrValue : 'gender'},
                                    {attrName : 'name', attrValue : 'gender'},
                                    {attrName : 'id',   attrValue : 'gender'},
                                    {attrName : 'title', attrValue : 'sex'},
                                    {attrName : 'name', attrValue : 'sex'},
                                    {attrName : 'id',   attrValue : 'sex'},
                                    {attrName : 'title', attrValue : 'man'},
                                    {attrName : 'name', attrValue : 'man'},
                                    {attrName : 'id',   attrValue : 'man'}]},
                         {type   : 'hidden',
                          checks : [{attrName : 'title', attrValue : 'gender'},
                                    {attrName : 'name', attrValue : 'gender'},
                                    {attrName : 'id',   attrValue : 'gender'},
                                    {attrName : 'title', attrValue : 'sex'},
                                    {attrName : 'name', attrValue : 'sex'},
                                    {attrName : 'id',   attrValue : 'sex'},
                                    {attrName : 'title', attrValue : 'man'},
                                    {attrName : 'name', attrValue : 'man'},
                                    {attrName : 'id',   attrValue : 'man'}]}]
        },
        {
            kpm_type: 'Identity_Contact_EMail',
            required: false,
            inputIndexes: [],            
            maxInputs: 2,            
            predicates: [{type   : 'email',
                          checks : []},
                         {type   : '*',
                          checks : [{attrName : 'title', attrValue : 'mail'},
                                    {attrName : 'name', attrValue : 'mail'},
                                    {attrName : 'id',   attrValue : 'mail'}]}]
        },
        {
            kpm_type: 'Identity_Person_Language',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'lang'},
                                    {attrName : 'name', attrValue : 'lang'},
                                    {attrName : 'id',   attrValue : 'lang'}]}]
        },                
        {
            kpm_type: 'Identity_Contact_Country',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'option',
                          checks : [{attrName : 'title', attrValue : 'countr'},
                                    {attrName : 'name', attrValue : 'countr'},
                                    {attrName : 'id',   attrValue : 'countr'}]}]
        },
        {
            kpm_type: 'Identity_Contact_City',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'city'},
                                    {attrName : 'name', attrValue : 'city'},
                                    {attrName : 'id',   attrValue : 'city'},
                                    {attrName : 'title', attrValue : 'town'},
                                    {attrName : 'name', attrValue : 'town'},
                                    {attrName : 'id',   attrValue : 'town'}]}]
        },        
        {
            kpm_type: 'Identity_Contact_Zip',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'post'},
                                    {attrName : 'name', attrValue : 'post'},
                                    {attrName : 'id',   attrValue : 'post'},
                                    {attrName : 'title', attrValue : 'code'},
                                    {attrName : 'name', attrValue : 'code'},
                                    {attrName : 'id',   attrValue : 'code'}]}]
        },
        {
            kpm_type: 'Identity_Contact_MobilePhone',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'phon'},
                                    {attrName : 'name', attrValue : 'phon'},
                                    {attrName : 'id',   attrValue : 'phon'},
                                    {attrName : 'title', attrValue : 'tel'},
                                    {attrName : 'name', attrValue : 'tel'},
                                    {attrName : 'id',   attrValue : 'tel'},
                                    {attrName : 'title', attrValue : 'mobil'},
                                    {attrName : 'name', attrValue : 'mobil'},
                                    {attrName : 'id',   attrValue : 'mobil'}]},
                         {type   : 'tel',
                          checks : [{attrName : 'title', attrValue : 'phon'},
                                    {attrName : 'name', attrValue : 'phon'},
                                    {attrName : 'id',   attrValue : 'phon'},
                                    {attrName : 'title', attrValue : 'tel'},
                                    {attrName : 'name', attrValue : 'tel'},
                                    {attrName : 'id',   attrValue : 'tel'},
                                    {attrName : 'title', attrValue : 'mobil'},
                                    {attrName : 'name', attrValue : 'mobil'},
                                    {attrName : 'id',   attrValue : 'mobil'}]}                                    ]
        },
        {
            kpm_type: 'Identity_Contact_HomePhone',
            required: false,
            inputIndexes: [],
            maxInputs: 1,
            predicates: [{type   : 'text',
                          checks : [{attrName : 'title', attrValue : 'phon'},
                                    {attrName : 'name', attrValue : 'phon'},
                                    {attrName : 'id',   attrValue : 'phon'}]},
                         {type   : 'tel',
                          checks : [{attrName : 'title', attrValue : 'phon'},
                                    {attrName : 'name', attrValue : 'phon'},
                                    {attrName : 'id',   attrValue : 'phon'}]}                                    ]
        }        
    ]
}
];

var HeuristicParser = 
{
    checkFormAgainstTemplate: function(template, formObject)
    {
        var filledTemplate = {
          'kpm_templateId' : template.id,
          'form_fields' : [],
          'all_fields' : []
        };
        
        var hiddenFieldsInForm = 0;
        for(var i = 0; i < formObject['input_elements'].length; i++)
            if(formObject['input_elements'][i]['@attributes']['type'] == 'hidden' && ((typeof template.can_have_hidden_fields == 'undefined') || (!template.can_have_hidden_fields)))
                hiddenFieldsInForm++;

        if(typeof formObject.has_submit != 'undefined' && (!formObject.has_submit)) return filledTemplate;
        if(template.max_fields_in_form != -1 && (formObject['input_elements'].length - hiddenFieldsInForm) > template.max_fields_in_form) return filledTemplate;
        if(template.min_fields_in_form != -1 && (formObject['input_elements'].length - hiddenFieldsInForm) < template.min_fields_in_form) return filledTemplate;                

        // Check if form contains unproper elements
        if(typeof template.must_not_contain !== 'undefined')
        {
            for(var j = 0; j < template.must_not_contain.length; j++)            
            {
                var t = template.must_not_contain[j];                
                var t_amount = 0;
                for(var i = 0; i < formObject['input_elements'].length; i++)
                {                    
                    var f = formObject['input_elements'][i];      
                    if(typeof t.type == 'undefined')
                        var typesArray = [];
                    else if(t.type instanceof Array)
                        var typesArray = t.type;
                    else
                        var typesArray = [t.type];
                        
                    for(var ttype in typesArray)
                    {
                        if((typeof f['@attributes']['type'] !== 'undefined' && typeof typesArray[ttype] !== 'undefined' && f['@attributes']['type'].toUpperCase() === typesArray[ttype].toUpperCase()))
                        {
                            t_amount++;
                            if(typeof t.max_amount !== 'undefined' && t_amount > t.max_amount)
                                return filledTemplate;                            
                        }
                    }
                    if((typeof $(f)[0].nodeName  !== 'undefined' && typeof t.nodeName !== 'undefined' && $(f)[0].nodeName.toUpperCase()  === t.nodeName.toUpperCase()))
                    {
                        t_amount++;
                        if(typeof t.max_amount !== 'undefined' && t_amount > t.max_amount)
                            return filledTemplate;                            
                    }                    
                }
                
                if(typeof t.min_amount !== 'undefined' && t_amount < t.min_amount)
                    return filledTemplate;
            }
        }
        
        for(var i = 0; i < formObject['input_elements'].length; i++)
        {      
            if(formObject['input_elements'][i]['@attributes']['type'] == 'hidden' && ((typeof template.can_have_hidden_fields == 'undefined') || (!template.can_have_hidden_fields)))
                continue;
            
            for(var j = 0; j < template.fields.length; j++)
            {
                for(var k = 0; k < template.fields[j].predicates.length; k++)
                {
                    if(formObject['input_elements'][i]['@attributes']['type'] == template.fields[j].predicates[k].type || template.fields[j].predicates[k].type == '*')
                    {
                        if(template.fields[j].predicates[k].checks.length == 0)
                        {
                            if(template.fields[j].inputIndexes.indexOf(i) == -1)
                            {
                                template.fields[j].inputIndexes.push(i);
                            }
                        }
                        else
                        {
                            for(var l = 0; l < template.fields[j].predicates[k].checks.length; l++)
                            {
                                var anotherAttrValue = formObject['input_elements'][i]['@attributes'][template.fields[j].predicates[k].checks[l].attrName];
                                if(anotherAttrValue && anotherAttrValue.toLowerCase().indexOf(template.fields[j].predicates[k].checks[l].attrValue) != -1)
                                {
                                    if(template.fields[j].inputIndexes.indexOf(i) == -1)
                                    {
                                        template.fields[j].inputIndexes.push(i);
                                    }
                                    break;
                                }                                
                            }
                        }
                    }   
                }    
            }
        }
         
        var shouldBeAdded = true;
        for(var j = 0; j < template.fields.length; j++)
        {
            if(template.fields[j].required == true &&
               (template.fields[j].inputIndexes.length == 0 || ((template.fields[j].inputIndexes.length > template.fields[j].maxInputs) && template.fields[j].exactNumber)))
            {
                shouldBeAdded = false;
                break;
            }
        }
        if(shouldBeAdded)
        {
            var alreadyUsedIndexes = [];
            filledTemplate['form_fields'] = [];
            for(var i = 0; i < template.fields.length; i++)
            {                
                //for(var j = 0; j < Math.min(template.fields[i].maxInputs, template.fields[i].inputIndexes.length); j++)
                template.fields[i].usedInputs = 0;
                for(var j = 0; j < template.fields[i].inputIndexes.length; j++)                
                {                    
                    if(template.fields[i].usedInputs == template.fields[i].maxInputs) break;
                    if(alreadyUsedIndexes.indexOf(template.fields[i].inputIndexes[j]) == -1)
                    {                        
                        if(typeof(formObject['input_elements'][template.fields[i].inputIndexes[j]]) == 'undefined') continue;
                        filledTemplate['form_fields'].push({'transform'   : template.fields[i].transform,
                                                            'kpm_type'    : template.fields[i].kpm_type,
                                                            'input_name'  : formObject['input_elements'][template.fields[i].inputIndexes[j]]['@attributes']['name'],
                                                            'input_id'    : formObject['input_elements'][template.fields[i].inputIndexes[j]]['@attributes']['id']});                                                    
                        template.fields[i].usedInputs+=1;
                        alreadyUsedIndexes.push(template.fields[i].inputIndexes[j]);
                    }
                }
            }
        }
        
        if(template.unknown_fields_allowed == false)
        {
            if((formObject['input_elements'].length - hiddenFieldsInForm) > filledTemplate['form_fields'].length)
            {
                return {
                  'kpm_templateId' : template.id,
                  'form_fields' : [],
                  'all_fields' : []
                };
            }
        }
        
        return filledTemplate;
    },

    parseUnknownForm: function(formObject)
    {
        for(var i = 0; i < heuristicFormTemplates.length; i++)
        {
            for(var j = 0; j < heuristicFormTemplates[i].fields.length; j++)
                heuristicFormTemplates[i].fields[j].inputIndexes = [];
            
            var anotherHFTResult = HeuristicParser.checkFormAgainstTemplate(heuristicFormTemplates[i], formObject);
            if(typeof console     != 'undefined' &&
               typeof console.log != 'undefined')
            {
                console.log('another HFT candidate:');            
                console.log(formObject);
            }
            if(anotherHFTResult['form_fields'].length > 0)
            {
                if(typeof formObject['@attributes'] != 'undefined' && typeof formObject['@attributes']['action'] != 'undefined')
                    anotherHFTResult['action'] = formObject['@attributes']['action'];
                else
                    anotherHFTResult['action'] = '';
                
                if(typeof console     != 'undefined' &&
                   typeof console.log != 'undefined')
                {
                  console.log('anotherHFTResult: ');
                  console.log(anotherHFTResult);
                }
                return anotherHFTResult;                
            }
        }
        
        return {
          'kpm_templateId' : 'empty_form',
          'form_fields' : []
        };
    }    
    // parseUnknownInput: function(input)
    // {
    //     
    // }
};