if(typeof(CustomEvent) == 'undefined' || !CustomEvent)
{
    CustomEvent = function(name, obj)
    {
        var event = document.createEvent('Event');        
        event.initEvent(name, true, true);
        event.detail = obj.detail;
        return event;
    };
}

var BrowserSpecific = {
    GetDocument: function()
    {
        return document;
    },
    logMessage: function(message)
    {
        KPMDataProvider.logi(message);
    },
    
    ///
    /// These methods should be overridden in case of different data-providing mechanism
    ///
    // handler for NP Plugin
    handleParsedFormObject: function(obj) // this method is environment-specific
    {
		var r = KPMDataProvider.handleParsedFormObject(window.location.href, JSON.stringify(obj));
		var v = JSON.parse(r);
		var fillFormStr = v.fillForm;
		if(typeof(fillFormStr) != 'undefined')
		{
			var fillForm = JSON.parse(fillFormStr);
			setTimeout(function()
				{
					KPM.FillForm(fillForm);
				}, 0);
		}

		var addUserStr = v.addUser;
		if(typeof(addUserStr) != 'undefined')
		{
			setTimeout(function()
				{
					eval( "KPM.AskUser(" + addUserStr + ");" ); 
				}, 0);
		}
	},

    UpdateDatabase: function(template)
    {
    },

    plugin: function()
    {
		return BrowserSpecific;
    },

    // browsers extensions methods    
    debugMessage: function(message) {KPMDataProvider.logd(message);},    
    errorMessage: function(message) {KPMDataProvider.loge(message);},    
    setUpEventListeners: function(settingsListener, messageListener, commandListener) {},
    eventsListener: function(event) {},
    getSetting: function(settingName) {},
    setSetting: function(settingName, settingValue) {},

    dispatchMessage: function(type, message) {
        var event = new CustomEvent(type, {detail: {message: message}});  
        document.dispatchEvent(event);
    },

    loadCss: function() {
    	console.log("BrowserSpecific.loadCss");
        var cssHtml = KPMDataProvider.getCssHtml();
        var node = BrowserSpecific.GetDocument().createElement("style");
        node = BrowserSpecific.GetDocument().getElementsByTagName("head")[0].appendChild(node);
        node.setAttribute("type","text/css");
        node.innerHTML = cssHtml;
    },

    addEventListener: function(name, handler, flag) {},
    dispatchToActiveTab: function(name, message) {},
    dispatchToAllTabs: function(name, message) {}
};

BrowserSpecific[callback] = function()
{
	var loginId = arguments[0];
	var formIndex = arguments[1];
	var formStr = KPMDataProvider.fillForm(loginId.toString(), formIndex.toString());
	var obj = JSON.parse(formStr);
	KPM.FillForm(obj);
	KPM.SubmitForm(obj);
};

BrowserSpecific[askIfSaveNewLoginPasswordCallback] = function(updatedData, template)
{
    var updatedDataStr = JSON.stringify(updatedData);
    var templateStr = JSON.stringify(template);
    var resultStr = KPMDataProvider.askIfSaveNewLoginPassword(updatedDataStr, templateStr);
    try
    {
        var result = JSON.parse(resultStr);
        var paramsStr = result.params;
        var newTemplateStr = result.template; 
        if(typeof(paramsStr) != 'undefined' && typeof(newTemplateStr) != 'undefined')
        {
            UI.AskIfChangePasswordInKPM(newTemplateStr, paramsStr);
        }
    }
    catch (e)
    {
        console.log("BrowserSpecific::askIfSaveNewLoginPasswordCallback error " + e.toString());
    }
};

BrowserSpecific.GetDocument().addEventListener("kpm_shouldPerformAutologin", function(event)
{                        
	var autoLogin = KPMDataProvider.getAutoLogin();
	if (autoLogin == '1')
	{
		var evnt = new CustomEvent('kpm_shouldPerformAutologinResponse', {detail: {shouldPerform: 1}});  
		BrowserSpecific.GetDocument().dispatchEvent(evnt);
	}
}, false);
