// [FIXME] Get rid of global object
if(typeof(window.shouldhave) == 'undefined')
    window.shouldhave = {
        accounts: false,
        identities: false,
        recentAccounts: true,
        masterpass: false
    };

var UI = {
    baseStateListenersInited: false,
    InitBaseStateListeners: function()
    {
        if(!window.baseStateListenersInited)
        {
            // [TODO] move this to KPM.js
            window.document.addEventListener('kpm_openKPM_event', function(event){
                BrowserSpecific.plugin()['kpm_openKPMCallback']();
            }, false);
            window.document.addEventListener('kpm_lockVault_event', function(event){
                BrowserSpecific.plugin()['kpm_lockVaultCallback']();
            }, false);
            window.document.addEventListener('kpm_mutation_updatepopover_event', function(event){
                BrowserSpecific.dispatchMessage('kpm_popover_update', {url : window.document.location.href, baseUnlocked : 1, requestType : 'accounts'});
            });
            window.document.addEventListener('kpm_unlocked_event', function(event){
                window.shouldhave.masterpass = false;
                window.shouldhave.recentAccounts = true;
                UI.locked = 0;                
                UI.RemoveMasterPassInterface();
                $(BrowserSpecific.GetDocument().body).find('div[class=\'kpm_dialogOuterBoxAssigned\']').show();                
                BrowserSpecific.dispatchMessage('kpm_popover_update', {url : window.document.location.href, baseUnlocked : 1, requestType : 'accounts'});
            }, false);
            window.document.addEventListener('kpm_locked_event', function(event){
                window.shouldhave.masterpass = true;
                window.shouldhave.recentAccounts = false;
                UI.locked = 1;    
                UI.AskMasterPassword();
                BrowserSpecific.dispatchMessage('kpm_popover_update', {url : window.document.location.href, baseUnlocked : 0, requestType : 'masterpass'});
            }, false);        
            window.baseStateListenersInited = true;
        }
    },
    GetBase64Image: function(img)
    {
        var canvas = document.createElement('canvas');        
        canvas.width = img.width;
        canvas.height = img.height;       
        var ctx = canvas.getContext('2d');
        ctx.drawImage(img, 0, 0);
        try
        {
            // var dataURL = canvas.toDataURL('image/png');
            var dataURL = canvas.toDataURL('image/png');
        }        
        catch(err)
        {
            var dataURL = '';
        }
        return dataURL.replace(/^data:image\/(png|jpg);base64,/, '');
    },
    Localization: {
        getString: function(token)
        {
            // [FIXME] global object is bad
            if(typeof(window.kpmLocalization) == 'undefined')
            {
                if(typeof(Localization.getString) == 'undefined')
                    return Localization[token];
                else
                    return Localization.getString(token);                
            }
            else
            {
                if(typeof(window.kpmLocalization.getString) == 'undefined')
                    return window.kpmLocalization[token];
                else
                    return window.kpmLocalization.getString(token);
            }
        }
    },
    CreateDummyPopover: function()
    {
        // var masterPasswordImage = $('<div/>').addClass('kpm_masterPasswordImage');    
        var dummy = $('<div/>').addClass('kpm_dummyPopover');//.append(masterPasswordImage);
        
        return dummy;
    },
    CreateMasterPasswordForm: function(masterpassInput)
    {
        // var outerBoxLogo = $('<div/>').addClass('kpm_dialogOuterBoxLogo');
        // var masterPasswordImage = $('<div/>').addClass('kpm_masterPasswordImage');
        // var masterPasswordImageActivated = $('<div/>').addClass('kpm_masterPasswordImageActivated');
        var masterPasswordText = $('<div/>').addClass('kpm_masterPasswordText').text(UI.Localization.getString('masterPasswordUnlockText'));
        var textboxInput = $('<input/>');
        textboxInput.attr('type', 'password');
        textboxInput.addClass('kpm_masterPasswordInput');
        textboxInput.attr('placeholder', UI.Localization.getString('masterPasswordText'));
        textboxInput.bind('input', function(e){
            if($(this).val().length > 0)
            {             
                $('.kpm_masterPasswordImage').attr('style', 'display:none !important;');
                $('.kpm_masterPasswordImageActivated').attr('style', 'display:block !important;');
            }
            else
            {
                $('.kpm_masterPasswordImage').attr('style', 'display:block !important;');
                $('.kpm_masterPasswordImageActivated').attr('style', 'display:none !important;');
            }
        });
        var submitButton = $('<div/>');
        // submitButton.attr('type', 'submit');
        submitButton.addClass('kpm_masterPasswordSubmit');
        submitButton.attr('value', UI.Localization.getString('unlockButton'));
        submitButton.append(masterPasswordText);
        submitButton.click(masterpassInput);
        $(textboxInput).keypress(function(event){
            if(event.which == 13)
            {
                event.preventDefault();
                masterpassInput(event);
            }            
        });
        var userPassVisibility = $('<div/>').addClass('kpm_passwordVisibility').addClass('kpm_masterPasswordVisibility').on('click', function(){
            var userPass = $('.kpm_masterPasswordInput').val();
            var newInput = $('<input/>').attr('type', ($('.kpm_masterPasswordInput').attr('type') == 'password')?'text':'password').addClass('kpm_masterPasswordInput').val(userPass);
            $('.kpm_masterPasswordInput').replaceWith(newInput);
        });        
        var inputContainer = $('<div/>').addClass('kpm_masterPasswordInputContainer').append(textboxInput).append(userPassVisibility).append(submitButton);
        // .append(outerBoxLogo).append(masterPasswordImage).append(masterPasswordImageActivated.attr('style', 'display:none !important;'))
        var form = $('<div/>').addClass('kpm_masterPasswordForm').append(inputContainer);
        return form;
    },
    CleanPageAndPopover: function(state)
    {
        // Clean popover
        BrowserSpecific.dispatchMessage('kpm_cleanpopover', {});   
        // BrowserSpecific.dispatchMessage('kpm_popover_update', {url : window.document.location.href, baseUnlocked : state, requestType: 'all'});      
        
        // Clean DOM
        $(BrowserSpecific.GetDocument().body).find('div[class=\'kpm_dialogOuterBox\']').remove();
        if(!state)
            // $(BrowserSpecific.GetDocument().body).find('div[class=\'kpm_dialogOuterBoxAssigned\']').remove();
        $(BrowserSpecific.GetDocument().body).find('div[class=\'kpm_dialogOuterBoxAssigned\']').hide();        
    },
    AskMasterPassword: function() // [TODO] move this somewhere too, this is not a UI
    {
        window.shouldhave.masterpass = true;
        
        if(typeof KPM != 'undefined' && KPM && !KPM.masterPassConnectionExists)
        {                        
            KPM.masterPassConnectionExists = true;
            KPM.SetUpConnectionWithPopover(arguments, 'masterpass', 'kpm_masterpass_fill_data', function(userPassword){
                BrowserSpecific.plugin()[callback](userPassword);
            });
        }       
        UI.CleanPageAndPopover(0);        
    },
    TellThereIsNoConnection: function()
    {
        UI.CleanPageAndPopover(-1);
    },
    RemoveMasterPassInterface: function()
    {
        UI.CleanPageAndPopover(1);        
        // [FIXME] why was this call here?
        UI.AttachAndDisplayDialog();
    },
    NoConnection: function()
    {
        BrowserSpecific.dispatchMessage('kpm_cleanpopover', {});   
        BrowserSpecific.dispatchMessage('kpm_popover_update', {url : window.document.location.href, baseUnlocked : -1});      
    },
    GetFaviconUrl: function()
    {
        // var iconUrl = '\'http://www.google.com/s2/favicons?domain=' + window.location.href.split('//')[1].split('/')[0] + '\'';                
        var iconUrl2 = $(BrowserSpecific.GetDocument().head).find('link[rel=\'shortcut icon\']').attr('href');
        if(typeof(iconUrl2) == 'undefined' || iconUrl2.length == 0)
            iconUrl2 = $(BrowserSpecific.GetDocument().head).find('link[rel=\'icon\']').attr('href');
        if(typeof(iconUrl2) == 'undefined' || iconUrl2.length == 0)
            iconUrl2 = $(BrowserSpecific.GetDocument().head).find('link[rel=\'apple-touch-icon-precomposed\']').attr('href');            
        if(typeof(iconUrl2) == 'undefined' || iconUrl2.length == 0)
            iconUrl2 = window.location.href.split('//')[0] + '//' + window.location.href.split('//')[1].split('/')[0] + '/favicon.ico';        
            
        if(iconUrl2.split('//').length == 0)
            iconUrl2 = window.location.href.split('//')[1].split('/')[0] + iconUrl2;

        return $('<img class=\'kpm_outerBoxFavicon\' src=\'' + iconUrl2 + '\'/>');
    },
    AskForSelection: function()
    {               
        if(arguments[0].length == 2)
            return;
            
        $(this).parents('.kpm_dialogOuterBox').remove();
        $(this).parents('.kpm_dialogOuterBoxAssigned').remove();            
        
        // BrowserSpecific.dispatchMessage('kpm_popover_update', {url : window.document.location.href, baseUnlocked : 1, requestType : 'accounts'});      
        
        var variants = [];
        var variantSelectFunction = function()
        {
            // [TODO] get rid of this one-element-sized array
            BrowserSpecific.plugin()[callback]([$(this).attr('value')], $(this).parent().attr('form_index'));            
            $(this).parents('.kpm_dialogOuterBox').remove();
            $(this).parents('.kpm_dialogOuterBoxAssigned').remove();            
        };
                
        for(var i = 1; i < arguments[0].length; i++)
            if(typeof arguments[0][i][0] !== 'undefined' && arguments[0][i][0].length > 0 && arguments[0][i][0] !== '')
                // [TODO] из плагина передаются разные, почему здесь одинаковые?
                variants.push({value   : arguments[0][i][0],
                               html    : arguments[0][i][1]});
        if(variants.length <= 0)
            return;
        var favicon = $(UI.GetFaviconUrl()).addClass('kpm_outerBoxFavicon');
        var accountName = $('<div/>').addClass('kpm_accountNameLabel').text(arguments[0][1][1]);
        var listContainer = $(UI.CreateKPMVariantsList(variants, variantSelectFunction)).attr('form_index', arguments[0][0][0]);
        $(listContainer).find('.b_kpmww__menu_item_link').each(function(){
            // [FIXME] hack for paddings/margins
            $(this).addClass('b_kpmww__menu_item_link_force');
        });
        var outerBoxContent = $('<div/>').addClass('kpm_outerBoxContent').append(listContainer); /*.append(favicon).append(accountName)*/
        
        // find positioning element
        var elementToStick = '';        
        var action = arguments[0][0][2];
        var formObject;
        var fakeFormObject;

        if (action !== '')
       	{
            formObject = $('form[action=\'' + arguments[0][0][2] + '\']')[0];
            fakeFormObject = $('form[action=\'' + arguments[0][0][2] + '_kpm_fake_form\']')[0];
        }
        else
        {
        	var formsLength = BrowserSpecific.GetDocument().forms.length;
            for(var index = 0; index < formsLength; ++index)
           	{
   	   	   	   	var frm = BrowserSpecific.GetDocument().forms[index];
   	   	   	   	var act = frm.action;
   	   	   	   	if (typeof act == 'undefined' || act == '')
   	   	   	   	{
   	   	   	   	   	formObject = frm;
   	   	   	   	}
   	   	   	   	else if (act == '_kpm_fake_form')
   	   	   	   	{
   	   	   	   	   	fakeFormObject = frm;
   	   	   	   	}
   	   	   	}
        }

        var fillFormFunction = function(formObject)
        {
            var elementToStick = '';
            if(!$(formObject).is(':visible')) return elementToStick;
            for(var index in formObject)
            {

                // check if form is visible
                // [FIXME] form itself may be visible, but childrens may be invisible
                //if(!$(formObject).is(':visible')) continue;

                var stickingCandidate = formObject[index];

                if(typeof stickingCandidate != 'object') continue;
                var ttype;
                try { ttype = $(stickingCandidate).attr('type'); } catch(e) { continue; }
                if(typeof ttype == 'undefined' || ttype != 'hidden')
                {
                    if(!$(stickingCandidate).is('input')) continue;
                    // Hide/show selection box if user inputs smth to the form
                    $(stickingCandidate).keyup(function(event){
                        if($(event.target).val().length == 0 && UI.locked == 0)
                            $('.kpm_dialogOuterBoxAssigned').css({'display' : 'block'});
                        else
                            $('.kpm_dialogOuterBoxAssigned').css({'display' : 'none'});
                    });            
                    
                    if(elementToStick == '' && stickingCandidate instanceof HTMLElement)
                        elementToStick = stickingCandidate;
                    // break;
                }
            }
            return elementToStick;
        };
        elementToStick = fillFormFunction(formObject);
        elementToStick = fillFormFunction(fakeFormObject);
        
        UI.lastDialog = UI.CreateKPMDialog(UI.Localization.getString('extensionName'), outerBoxContent, elementToStick);
        
        if(UI.lastElementToStick !== elementToStick)
        {
            UI.lastElementToStick = elementToStick;
            UI.AttachAndDisplayDialog();
        }
    },
    AttachAndDisplayDialog: function()
    {
        if(typeof(UI.lastDialog) == 'undefined')
            return;
            
        // make dialog invisible
        $(UI.lastDialog).css({'display' : 'none'});
        // inject to the page
        $(BrowserSpecific.GetDocument().body).append(UI.lastDialog);        
        // adjust positioning
        UI.StickDialogPositionToElement(UI.lastDialog, UI.lastElementToStick);
        // make dialog visible
        if($(UI.lastElementToStick).is(':visible'))
            $(UI.lastDialog).css({'display' : 'block'});             
            // $(UI.lastDialog).slideToggle({'duration' : 'fast', 'easing' : 'swing'});
    },
    AskIfChangePasswordInKPM: function(template, params)
    {        
        template = KPMjQuery.parseJSON(template);
        params = KPMjQuery.parseJSON(params);


        if(typeof params['baseIsLocked'] !== 'undefined')
        {
            KPM.SubmitForm(template);
            return true;            
        }

        var yesButton = UI.CreateKPMDialogButton(UI.Localization.getString('yesButton'), function() {            
            if(params.templateId == 'simpleLoginPasswordCheckboxForm')
            {
                // User changed login and password in dialog, put it back
                for(var i in template['form_fields'])
                {
                    if(typeof template['form_fields'][i] != 'undefined' && typeof template['form_fields'][i]['kpm_type'] != 'undefined')
                    {
                        var currentForm = $('form[action=\'' + template['action'] + '_kpm_fake_form' + '\']');                        
                        if(template['form_fields'][i]['kpm_type'] == 'login' || template['form_fields'][i]['kpm_type'] == 'password')
                        {                            
                            if($('#kpm_accountNameInput').is('input'))
                                template['form_fields'][i]['accountName'] = $('#kpm_accountNameInput').val();
                            else
                                template['form_fields'][i]['accountName'] = $('#kpm_accountNameInput').text();                            
                            
                            if(typeof template['form_fields'][i]['input_name'] != 'undefined')
                            {
                                if(params.loginFieldChanged)
                                    template['form_fields'][i]['kpm_value'] = (template['form_fields'][i]['kpm_type'] == 'login')?$('.kpm_userNameInput').val():$('.kpm_userPasswordInput').val();
                                else
                                    template['form_fields'][i]['kpm_value'] = $(currentForm).find('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();
                                $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val(template['form_fields'][i]['kpm_value']);
                            }
                            else if(typeof template['form_fields'][i]['input_id'] != 'undefined')
                            {
                                template['form_fields'][i]['kpm_value'] = $(currentForm).find('input[id=\'' + template['form_fields'][i]['input_id'] + '\']').val();                                
                                template['form_fields'][i]['kpm_value'] = $('.kpm_userNameInput').val();                                                            
                                $('input[name=\'' + template['form_fields'][i]['input_id'] + '\']').val(template['form_fields'][i]['kpm_value']);
                            }
                        }
                    }
                }
            }
            
            KPM.UpdateDatabase(template);

            $(this).parents('.kpm_dialogOuterBox').remove();                                    
            $(this).parents('.kpm_dialogOuterBoxAssigned').remove();                                                
        });
        var noButton = UI.CreateKPMDialogButton(UI.Localization.getString('noButton'), function() {
            $(this).parents('.kpm_dialogOuterBox').remove();
            $(this).parents('.kpm_dialogOuterBoxAssigned').remove();                                                
            KPM.DoNotUpdateDatabase(template);
        });
        var favicon = $('<div/>').addClass('kpm_outerBoxFaviconContainer').append(UI.GetFaviconUrl());
        // var labelToInput = function(){
        //     var input = $('<input id=\'kpm_accountName_input\' type=\'text\'/>').addClass('kpm_accountNameInput').val($(this).parent().children('.kpm_accountNameLabel').text());
        //     $(this).parent().append(input);
        //     $(this).parent().children('.kpm_accountNameLabel').remove();            
        // };        
        
        if(params.templateId == 'simpleLoginPasswordCheckboxForm')
        {
            var newLoginName = '';
            var newLoginPass = '';             
            for(var i  = 0; i < template['form_fields'].length; i++)
            {
                if(template['form_fields'][i]['kpm_type'] == 'login')
                {
                    newLoginName = $('#' + template['form_fields'][i]['input_id']).val(); 
                    if(typeof(newLoginName) == 'undefined')
                        newLoginName = $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();
                }
                if(template['form_fields'][i]['kpm_type'] == 'password')
                {
                    newLoginPass = $('#' + template['form_fields'][i]['input_id']).val();
                    if(typeof(newLoginPass) == 'undefined')
                        newLoginPass = $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();
                }
            }             
            var newAccountName = template['form_fields'][0]['accountName'];              

            if(typeof(newLoginName) == 'undefined' ||
               newLoginName.length == 0)
            {
                // [TODO] shoudn't there be SubmitForm?
                return false;
            }
                           
            if(params.loginFieldChanged)
            {            
                var accountName = $('<input id=\'kpm_accountNameInput\' type=\'text\'/>').addClass('kpm_accountNameInput').val(newAccountName);
                // var outerBoxContentText = $('<div/>').addClass('kpm_dialogOuterBoxText').text(UI.Localization.getString('addNewAccount'));                    
                var userName = $('<input/>').addClass('kpm_userNameInput').val(newLoginName);                    
                var userPassVisibility = $('<div/>').addClass('kpm_passwordVisibility').on('click', function(){
                    var userPass = $('.kpm_userPasswordInput').val();
                    var newInput = $('<input/>').attr('type', ($('.kpm_userPasswordInput').attr('type') == 'password')?'text':'password').addClass('kpm_userPasswordInput').val(userPass);
                    $('.kpm_userPasswordInput').replaceWith(newInput);
                });
                var bindDialogButton = $('<div/>').addClass('kpm_linkDialogButton').on('click', function(){
                    if($(BrowserSpecific.GetDocument().body).find('.kpm_bindList').length == 0)
                        BrowserSpecific.plugin()[injectLinkListDataCallback]();
                });            
                var userPass = $('<input type=\'password\'/>').addClass('kpm_userPasswordInput').val(newLoginPass);            
            
                var bigText = $('<div/>').addClass('kpm_dialogOuterBoxText').text(UI.Localization.getString('saveNewLoginOrPassSharedText'));
                var smallText = $('<div/>').addClass('kpm_dialogOuterBoxTextAux').text(UI.Localization.getString('saveNewPasswordForAccount'));            
            
                var outerBoxContent = $('<div/>').addClass('kpm_outerBoxContentContainer').append(bigText).append(smallText).append(favicon).append(accountName).append(userName).append(bindDialogButton).append($('<div/>').addClass('kpm_dialogSeparatorShort')).append(userPass).append(userPassVisibility);
            }
            else if(params.passwordFieldChanged)
            {
                // [TODO] check if password length > 0 and disable Save button
                var accountName = $('<div id=\'kpm_accountNameInput\'/>').addClass('kpm_accountNameLabel').text(newAccountName);
                // var outerBoxContentText = $('<div/>').addClass('kpm_dialogOuterBoxText').text(UI.Localization.getString('saveNewPasswordForAccount'));
                var userName = $('<div/>').addClass('kpm_userName').text(newLoginName);                                    

                var contentTop = $('<div/>').addClass('kpm_outerBoxContentTop');
                var contentBottom = $('<div/>').addClass('kpm_outerBoxContentBottom');            
                var contentMiddle = $('<div/>').addClass('kpm_outerBoxContentMiddle').append(favicon).append(accountName).append(userName);

                var bigText = $('<div/>').addClass('kpm_dialogOuterBoxText').text(UI.Localization.getString('saveNewLoginOrPassSharedText'));
                var smallText = $('<div/>').addClass('kpm_dialogOuterBoxTextAux').text(UI.Localization.getString('saveNewPasswordForAccount'));            

                var outerBoxContent = $('<div/>').addClass('kpm_outerBoxContentContainer').append(bigText).append(smallText).append(contentTop).append(contentMiddle).append(contentBottom);
            }
            else
            {
                KPM.SubmitForm(template);
                return true;                            
            }
        }
        else if(params.templateId == 'signupTemplate')
        {
            var firstName = '';
            var lastName = '';            
            var smthElse = '';
            for(var i  = 0; i < template['form_fields'].length; i++)
            {
                if(template['form_fields'][i]['kpm_type'] == 'Identity_Person_FirstName')
                {
                    firstName = $('#' + template['form_fields'][i]['input_id']).val();
                    if(typeof firstName == 'undefined')
                        firstName = $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();
                }
                else if(template['form_fields'][i]['kpm_type'] == 'Identity_Person_LastName')
                {
                    lastName = $('#' + template['form_fields'][i]['input_id']).val();
                    if(typeof lastName == 'undefined')
                        lastName = $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();                    
                }
                else
                {
                    var tmpSmthElse = '';
                    tmpSmthElse = $('#' + template['form_fields'][i]['input_id']).val();
                    if(typeof tmpSmthElse == 'undefined')
                        tmpSmthElse = $('input[name=\'' + template['form_fields'][i]['input_name'] + '\']').val();
                    
                    if(typeof tmpSmthElse != 'undefined')
                    {
                        if(smthElse == '')
                            smthElse = tmpSmthElse;
                        // [TODO] select relevant fields, now it's just the first one, email, if possible                    
                        // else
                        //     smthElse += ' ' + tmpSmthElse;
                    }
                }
            }

            var accountName = $('<div id=\'kpm_accountNameInput\'/>').addClass('kpm_accountNameLabel').text(firstName + ' ' + lastName);
            var userName = $('<div/>').addClass('kpm_userName').text(smthElse);

            var contentTop = $('<div/>').addClass('kpm_outerBoxContentTop');
            var contentBottom = $('<div/>').addClass('kpm_outerBoxContentBottom');            
            var contentMiddle = $('<div/>').addClass('kpm_outerBoxContentMiddle').append(accountName).append(userName);

            var bigText = $('<div/>').addClass('kpm_dialogOuterBoxText').text(UI.Localization.getString('saveNewIdentitySharedText'));
            var smallText = $('<div/>').addClass('kpm_dialogOuterBoxTextAux').text(UI.Localization.getString('saveNewIdentity'));            

            var outerBoxContent = $('<div/>').addClass('kpm_outerBoxContentContainer').append(bigText).append(smallText).append(contentTop).append(contentMiddle).append(contentBottom);
        }
        else
        {
            KPM.SubmitForm(template);
            return true;
        }
                            
        var dialog = UI.CreateKPMDialog(UI.Localization.getString('extensionName'), outerBoxContent, '', yesButton, noButton);
        $(dialog).css({'display' : 'none'});
        $(BrowserSpecific.GetDocument().body).append(dialog);
        
        // Isn't this animation cool, huh?
        $(dialog).slideToggle({'duration' : 'fast', 'easing' : 'swing', 'complete' : function(){
            //
        }});
        
        return false;
    },
    InjectLinkListData: function(listData)
    {        
        $('.kpm_linkListDialog').remove();
        
        var webVariants = [];
        var appVariants = [];
        for(var i = 0; i < listData.length; i++)
        {
            var item = listData[i];

            var anotherHtml = $('<div/>').addClass('kpm_linkDataItemContainer');
            var leftContainer = $('<div/>').addClass('kpm_linkListLeftContainer');
            leftContainer.append($('<div/>').addClass('kpm_linkListAccountName').text(item.accountName));
            leftContainer.append($('<div/>').addClass('kpm_linkListLoginName').text(item.loginName));            
            anotherHtml.append(leftContainer);
            if(item.isLinkedWithCurrentAccount == 'true')
                anotherHtml.append($('<div/>').addClass('kpm_linkListCheckbox_checked'));
            else
                anotherHtml.append($('<div/>').addClass('kpm_linkListCheckbox'));
                
            if(typeof(item.url) != 'undefined')
                webVariants.push({html  : anotherHtml,
                               value : item.accountName + ',' + item.loginName + ',' + item.url});
            else
                appVariants.push({html  : anotherHtml,
                               value : item.accountName + ',' + item.loginName + ',' + item.path});                
        }       
        var listsList = $('<div/>');
        var itemSelectionCallback = function(){            
            BrowserSpecific.plugin()[callback]($(this).attr('value').split(',')[2], $(this).attr('value').split(',')[1], $('.kpm_accountNameInput').val());            
            $('.kpm_bindList').remove();
            $('.kpm_dialogOuterBox').remove();
            $('.kpm_dialogOuterBoxAssigned').remove();
        };
        if(webVariants.length > 0)
            var webList = UI.CreateKPMVariantsList(webVariants, itemSelectionCallback, UI.Localization.getString('webAccountsLabel')).addClass('kpm_bindList');
        else
            var webList = $('<div/>');
        if(appVariants.length > 0)
            var appList = UI.CreateKPMVariantsList(appVariants, itemSelectionCallback, UI.Localization.getString('appAccountsLabel')).addClass('kpm_bindList');
        else
            var appList = $('<div/>');
        $(webList).each(function(){
          $(this).find('.b_kpmww__menu_item_link').addClass('b_kpmww__menu_item_link_force');
        });
        $(appList).each(function(){
          $(this).find('.b_kpmww__menu_item_link').addClass('b_kpmww__menu_item_link_force');
        });        
        listsList.append(webList).append(appList);        
        $(listsList).prepend(UI.CreateSearchField());
        
        if(webVariants.length > 0 || appVariants.length > 0)
            var dialog = UI.CreateKPMDialog(UI.Localization.getString('newLoginLinkHeader'), listsList, $('.kpm_linkDialogButton')[0]).addClass('kpm_linkListDialog');
        else
            var dialog = $('<div/>');
        
        dialog.css({'display' : 'none'});
        $(BrowserSpecific.GetDocument().body).append(dialog);       
        UI.StickDialogPositionToElement(dialog, $('.kpm_linkDialogButton')[0]);
        dialog.css({'left' : parseInt(dialog.css('left')) - 40})
        dialog.css({'z-index' : '2147483647'});
        dialog.css({'display' : 'block'});
        
        // if clicked outside the list, remove list
        $('html').click(function(){
            $('.kpm_linkListDialog').remove();
            // [TODO] remove event handler
        });
        $('.kpm_linkListDialog').click(function(event){
            event.stopPropagation();
        });
    },
    CreateSearchField: function()
    {
        var searchFieldChanged = function(obj){
            if($('.kpm_linkListDialog').find(':animated').length > 0)
            {
                // animation mutex
                setTimeout(function(){searchFieldChanged(obj); }, 100);
                return;
            }
            
            var currentInput = obj;        
            if(typeof $(currentInput).attr('kpm_dialogHeight') === 'undefined' || $(currentInput).parents('.kpm_dialogOuterBoxAssigned').height() > parseInt($(currentInput).attr('kpm_dialogHeight')))
            {
                if($(currentInput).parents('.kpm_dialogOuterBoxAssigned').length > 0)
                {
                    $(currentInput).attr('kpm_dialogHeight', $(currentInput).parents('.kpm_dialogOuterBoxAssigned').height());
                    $(currentInput).attr('kpm_dialogTop', $(currentInput).parents('.kpm_dialogOuterBoxAssigned').offset().top);    
                }
            }
                                    
            if($(currentInput).val().length > 0)
                $('.kpm_searchField_clear').css('display', 'block');
            else
                $('.kpm_searchField_clear').css('display', 'none');
            var allVars = $('.b_kpmww__menu_item');       
            for(var i = 0; i < allVars.length; i++)
            {
                if($(allVars[i]).text().toLowerCase().indexOf($(currentInput).val().toLowerCase()) == -1)
                {
                    if($(allVars[i]).attr('kpm_item_status') !== 'notvisible' && $(allVars[i]).attr('kpm_item_status') !== 'notinsearch')
                    {
                        $(allVars[i]).attr('kpm_original_height', parseInt($(allVars[i]).css('height')));                        

                        $(allVars[i]).attr('kpm_original_padding_top', $(allVars[i]).css('padding-top'));
                        $(allVars[i]).attr('kpm_original_padding_bottom', $(allVars[i]).css('padding-bottom'));                                                
                        $(allVars[i]).animate({'height'  : '0px',
                                               'padding-top' : '0px',
                                               'padding-bottom' : '0px',                                               
                                               'opacity'  : '0'}, function() {                                                   
                                                   $('.kpm_linkListDialog').each(function(){
                                                       var that = this;
                                                       $(this).find('.kpm_dialogShadowBox').each(function(){
                                                           $(this).height(parseInt($(that).height()) - 14); // [TODO] what does this magic number mean?
                                                       });
                                                   });
                                               });

                        $(allVars[i]).attr('kpm_item_status', 'notvisible');
                        $(allVars[i]).prev('.kpm_dialogSeparatorAssigned').hide();
                    }
                }
                else
                {
                    if($(allVars[i]).attr('kpm_item_status') === 'notvisible' && $(allVars[i]).attr('kpm_item_status') !== 'notinsearch')                    
                    {
                        $('.kpm_nothingVisible').remove();      
                                     
                        $(allVars[i]).show();                                                                                        
                        $(allVars[i]).animate({'padding-top' : $(allVars[i]).attr('kpm_original_padding_top'),
                                               'padding-bottom' : $(allVars[i]).attr('kpm_original_padding_bottom'),
                                               'opacity'  : '1',
                                               'height'  : $(allVars[i]).attr('kpm_original_height') + 'px'}, function() {                                                   
                                                   $('.kpm_linkListDialog').each(function(){
                                                       var that = this;
                                                       $(this).find('.kpm_dialogShadowBox').each(function(){
                                                           $(this).height(parseInt($(that).height()) - 14); // [TODO] what does this magic number mean?
                                                       });
                                                   });
                                               });                
                                               
                        $(allVars[i]).attr('kpm_item_status', 'visible');
                        $(allVars[i]).prev('.kpm_dialogSeparatorAssigned').show();
                    }
                }
            }
            
            var allSections = $('.kpm_dialogVariants,kpm_popover_underSearchFieldList');
            $(allSections).each(function(index){
                if($(allSections[index]).find('.b_kpmww__menu_item[kpm_item_status=\'visible\']').length === 0 && $(allSections[index]).find('.kpm_nothingVisible').length === 0)
                    $(allSections[index]).find('.b_kpmww__title').after($('<div/>').addClass('kpm_nothingVisible').text(UI.Localization.getString('popoverLabel_nothingFound')));
            });
        };
        var searchField = $('<div/>').addClass('kpm_dialogVairants_searchField_container').append($('<input type=\'text\'/>').addClass('kpm_dialogVairants_searchField').on('input', function(){
            searchFieldChanged(this);
        }));
        return searchField.append($('<div/>').addClass('kpm_searchField_icon')).append($('<div/>').addClass('kpm_searchField_clear').on('click', function(){
            $(this).parent().find('input').each(function(e){
                $(this).val('');
                searchFieldChanged(this);
            });
        }));
    },
    CreateKPMVariantsList: function(variants, callback, title, /*maxheight,*/ additionalHeader)
    {
        // [TODO] make our own classes               
        var container = $('<div/>').addClass('kpm_dialogVariants').append(additionalHeader);
        if(typeof(title) != 'undefined')
            container.append($('<div/>').addClass('b_kpmww__title').text(title));
            
        // var listContainer = $('<div/>');
        // if(maxheight == 1)
        //     listContainer.addClass('b_kpmww__menu_accounts');
            
        for(var i = 0; i < variants.length; i++)
        {
            if(!variants[i].html || variants[i].html.length == 0) continue;            
            if(i != 0)
                container.append($('<div/>').addClass('kpm_dialogSeparatorAssigned'));
            if(typeof(variants[i].html) == 'string')
                container.append($('<div/>').addClass('b_kpmww__menu_item_link_force').addClass('b_kpmww__menu_item').addClass('b_kpmww__menu_item_link').attr('value', variants[i].value).attr('kpm_item_status', 'visible').text(variants[i].html).click(callback));
            else
                container.append($('<div/>').addClass('b_kpmww__menu_item_link_force').addClass('b_kpmww__menu_item').addClass('b_kpmww__menu_item_link').attr('value', variants[i].value).attr('kpm_item_status', 'visible').append(variants[i].html).click(callback));
        }
        // container.append(listContainer);
        return container;
    },
    CreateKPMDialogButton: function(text, callback, segment)
    {
        if(typeof(segment) != 'undefined' && segment != '')
        {
            var segmentClass = 'Segment';
            var segmentButton = $('<div/>').addClass('kpm_dialogButtonDropdownSegment').on('click', function(){
                
                return false;
            });
        }
        else
        {
            var segmentClass = '';
            var segmentButton = '';
        }
        
        var left   = $('<div/>').addClass('kpm_dialogButtonLeft');
        var middle = $('<div/>').addClass('kpm_dialogButtonMiddle').text(text);
        var right  = $('<div/>').addClass('kpm_dialogButtonRight' + segmentClass);
        var button = $('<div/>').addClass('kpm_dialogButton').append(left).append(middle).append(right).click(callback);
        
        return $('<div/>').addClass('kpm_dialogButtonContainer').append(button).append(segmentButton);
    },
    CreateKPMToolbarDialog: function(text, content, bR, bL, assignedToElement)
    {
        if(typeof(assignedToElement) == 'undefined' || assignedToElement == '')
            var outerBox = $('<div/>').addClass('kpm_dialogOuterBoxPopover').append(content);
        else
            var outerBox = $('<div/>').addClass('kpm_dialogOuterBoxPopoverAssigned').append(content);
        return outerBox;
    },
    CreateKPMDialog: function(headerText, content, assignedToElement, bR, bL)
    {     
        if(typeof(assignedToElement) == 'undefined' || assignedToElement == '')        
            var ifAssigned = '';
        else
            var ifAssigned = 'Assigned';
        
        if(typeof(bR) != 'undefined')
            bR.addClass('kpm_dialogRightButton');
        if(typeof(bL) != 'undefined')            
            bL.addClass('kpm_dialogLeftButton');        
        
        if(typeof(content) != 'undefined' && content != '')
            var innerBox = $('<div/>').append(content);
        else
            var innerBox = $('<div/>');

        var dialogHeaderText = $('<div/>').addClass('kpm_dialogHeaderText').text(''); // headerText
        var dialogHeader = $('<div/>').addClass('kpm_dialogHeader' + ifAssigned).append(dialogHeaderText);       
        
        var outerBoxLogo = $('<div/>').addClass('kpm_dialogOuterBoxSideLogo');
        if(ifAssigned.length == 0)
        {
            var leftColumn = $('<div/>').addClass('kpm_dialogLeftColumn').append(outerBoxLogo);
            var rightColumn = $('<div/>').addClass('kpm_dialogRightColumn').append(innerBox).append(bL).append(bR);          
        }
        else
        {
            var leftColumn = $('<div/>');
            var rightColumn = $('<div/>').append(innerBox).append(bL).append(bR);          
        }
        var outerBoxMiddle  = $('<div/>').addClass('kpm_dialogOuterBoxMiddle' + ifAssigned).append(leftColumn).append(rightColumn);
            
        if(typeof(bL) != 'undefined' || typeof(bR) != 'undefined')
            $(outerBoxMiddle).attr('style', 'padding-bottom : 50px !important;');        
            
        var outerBoxBottom  = $('<div/>').addClass('kpm_dialogOuterBoxBottom' + ifAssigned);
        var outerBoxClose = $('<div/>'); //.addClass('kpm_dialogOuterBoxClose');  
        
        // var outerBox = $('<div/>').addClass('kpm_dialogOuterBox' + ifAssigned).append(dialogHeader).append($('<div/>').addClass('kpm_dialogSeparatorLong')).append(outerBoxMiddle).append(outerBoxBottom);
            
        var outerBox = $('<div/>').addClass('kpm_dialogOuterBox' + ifAssigned).append(dialogHeader).append($('<div/>').addClass('kpm_dialogSeparatorLong')).append(outerBoxMiddle).append(outerBoxBottom);
                
        // calculate top and left coordinates for dialog, standart is 30%
        var topDialogMargin = $(BrowserSpecific.GetDocument().body).height() * 0.3;        
        var leftDialogMargin = $(BrowserSpecific.GetDocument().body).width() * 0.3;
                
        // $(outerBox).css({ 'top' : topDialogMargin + 'px !important',
        //                   'left' : leftDialogMargin + 'px !important'});
                
        return outerBox.prepend($('<div/>').addClass('kpm_dialogShadowBox'));
    },
    localizationsListener: function(event) {          
        // [FIXME] refactor this trash
        // [FIXME] global object is bad
        if(typeof(event.detail) == 'string')
        {
            var newObj = JSON.parse(event.detail);
        }
        else
        {
            var newObj = event.detail;            
        }
        if(typeof(UI.Localization) == 'undefined')
        {
            UI.Localization = newObj;
        }
        // else
            window.kpmLocalization = newObj;
    },
    SetUpLocalizations: function()
    {
        if(typeof(window.kpmLocalization) != 'undefined')
            return;

        // [TODO] make hashed callback names
        document.addEventListener('kpm_localizations_response', UI.localizationsListener, false);
        BrowserSpecific.dispatchMessage('kpm_localizations', {callback: 'kpm_localizations_response'});        
    },
    StickDialogPositionToElement: function(dialog, element)
    {
        var top  = parseInt($(element).offset().top)  + parseInt($(element).height());        
        var left = parseInt($(element).offset().left);                
        
        // var location = { 'horizontal' : ((parseInt($(dialog).width()) + left) >= parseInt($(window).width())?'right':'left'),
        //                  'vertical'   : ((parseInt($(dialog).height()) + top) >= parseInt($(window).height())?'bottom':'top') };        
        var location = { 'horizontal' : ((parseInt($(dialog).width()) + left) >= parseInt($(window).width())?'right':'left'),
                         'vertical'   : ((parseInt($(dialog).height()) >= parseInt(top))?'top':'bottom') };        
                            
        $(dialog).css({'left' : $(element).offset().left - (location['horizontal'] == 'right'?$(dialog).width()*0.7:0),
                       'top'  : top - (location['vertical'] == 'bottom'?$(dialog).height()+11+$(element).height():(-11))});

        
                       
        $(dialog).find('.kpm_dialogHeaderAssigned').addClass('kpm_dialogHeaderAssigned_' + location['vertical'] + '_' + location['horizontal']);
        $(dialog).find('.kpm_dialogOuterBoxBottomAssigned').addClass('kpm_dialogOuterBoxBottomAssigned_' + location['vertical'] + '_' + location['horizontal']);
        $(dialog).find('.kpm_dialogHeaderText').addClass('kpm_dialogHeaderText_' + location['vertical'] + '_' + location['horizontal']);     
        
        // Adjust shadow box
        if(location['vertical'] == 'top')
        {
            $(dialog).find('.kpm_dialogShadowBox').each(function(){
                $(this).css({'height' : ($(this).parent().height() - 13) + 'px',
                             'top'    : ($(this).offset().top + 13) + 'px'});
            });            
        }
        if(location['vertical'] == 'bottom')
        {
            $(dialog).find('.kpm_dialogShadowBox').each(function(){
                $(this).css({'height' : ($(this).parent().height() - 13) + 'px'});
            });
        }
    } 
};
UI.InitBaseStateListeners();
